#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <utility>

using namespace std;

typedef map<string, int> msi;

#if 0
void fA() {
  int n, m;
  cin >> n >> m;
  if (n - 7 >= 1)
      cout << n - 7;
  else
      cout << m + 7;
}
#endif

int64_t count_bits(int64_t n)
{
    int64_t res {0};

    for (int64_t i {0}; i < 0x40; i++)
        res += (n >> i) & 1;

    return res;
}

void fE()
{
    int64_t n;
    cin >> n;

    while (n-- > 0)
    {
        int64_t val;

        cin >> val;

        val = abs(val);

        int64_t up {val};
        up |= (up >> 0x1);
        up |= (up >> 0x2);
        up |= (up >> 0x4);
        up |= (up >> 0x8);
        up |= (up >> 0x10);
        up |= (up >> 0x20);

        up = (up ^ (up >> 1)) << 1;

        int64_t down {up >> 1};
        up = up - val;
        down = val - down;

        cout << ((val == 0) ? 0 : std::min(count_bits(up), count_bits(down)) + 1) << "\n";
    }
}

void fD() {
    int q, c;
    cin >> q >> c;
    string pos, aim;
    msi newcolor;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            cin >> aim;
            newcolor[aim] = x;
        } else {
            cin >> aim;
            pos = "";
            int curcolor = -1;
            bool isColor = false;

            for (int j = 0; j < aim.size(); j++) {
                pos += aim[i];
                auto it = newcolor.find(pos);
                if (!isColor) {
                    if (aim[i] == 'L')
                        curcolor = (curcolor + 1) % c;
                    else
                        curcolor = (curcolor - 1 + c) % c;
                }
                if (it != newcolor.cend()) {
                    curcolor = it->second;
                    isColor = true;
                }
            }
            cout << curcolor << endl;
        }
    }
}



int main() {
    fD();
    return 0;
}
