#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define int ll

using vec = pair<ll, ll>;

#define x first
#define y second

ll cross_prod(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

ll dot_prod(vec a, vec b) {
    return a.x * b.x + a.y * b.y;
}

vec operator-(vec a, vec b) {
    return {a.x - b.x, a.y - b.y};
}

int sign(ll x) {
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

bool check(vec a, vec b, vec c) {
    return sign(cross_prod(c, a)) * sign(cross_prod(c, b)) <= 0;
}

bool cross(vec a, vec b, vec c, vec d) {
    if (dot_prod(b - a, d - c) == 0 && dot_prod(b - a, c - a) == 0) {
        if (check(a, b, c) || check(a, b, d) || check(c, d, a) || check(c, d, b)) return 1;
        return 0;
    }
    bool ok = sign(cross_prod(a - b, c - b)) * sign(cross_prod(a - b, d - b)) <= 0;
    swap(c, d);
    ok &= sign(cross_prod(a - b, c - b)) * sign(cross_prod(a - b, d - b)) <= 0;
    swap(c, d);
    swap(a, c);
    swap(b, d);
    ok &= sign(cross_prod(a - b, c - b)) * sign(cross_prod(a - b, d - b)) <= 0;
    swap(c, d);
    ok &= sign(cross_prod(a - b, c - b)) * sign(cross_prod(a - b, d - b)) <= 0;
    swap(c, d);
    return ok;
}

ll len2(vec a) {
    return a.x * a.x + a.y * a.y;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);


    int n;
    cin >> n;
    vector<pair<vec, vec>> a(n);
    for (auto & i : a) cin >> i.ff.ff >> i.ff.ss >> i.ss.ff >> i.ss.ss;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = 0;
                vector<pair<vec, vec>> b = {a[i], a[j], a[k]};
                do {
                    ok |= (cross(b[0].ff, b[0].ss, b[1].ff, b[1].ss));
                } while (next_permutation(all(b)));
                do {
                    ll dist = min({
                                          len2(b[0].ff - b[1].ff),
                                          len2(b[0].ff - b[1].ss),
                                          len2(b[0].ss - b[1].ff),
                                          len2(b[0].ss - b[1].ss)
                    });
                    if (dist <= len2(b[2].ff - b[2].ss)) ok = 1;
                } while (next_permutation(all(b)));
                ans += ok;
            }
        }
    }
    cout << ans;
}
//ABAABA