#include "bits/stdc++.h"
#define ll long long
using namespace std;

int k1=7,k2=31;
int mod1=1000000009,mod2=1000000007;

pair<int,int> sum(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (a.first + b.first) % mod1;
    res.second =  (a.second + b.second) % mod2;
    return res;
}

pair<int,int> mul(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (((ll)a.first) * ((ll)b.first)) % mod1;
    res.second =  (((ll)a.second) * ((ll)b.second)) % mod2;
    return res;
}

pair<int,int> sub(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (a.first + mod1 - b.first) % mod1;
    res.second =  (a.second + mod2 - b.second) % mod2;
    return res;
}

int main() {
    cin.sync_with_stdio(0);
    int n;
    cin >> n;
    vector<string> a;
    for(int i=0;i<n;i++){
        string s;
        cin >> s;
        a.push_back(s);
    }



    int p = a[0].size();
    int l=0,r=p+1;
    while(r-l > 1){
        int m = (l+r) / 2;
        map<string,int> mp;
        for(int i=0;i<n;i++){
            string ss;
            for(int j=0;j<m;j++){
                ss.push_back(a[i][j]);
            }
            mp[ss] ++;
        }
        bool ok = true;
        for(auto pointer = mp.begin();pointer != mp.end();pointer++){
            int z = pointer->second;
            if(z%2 != 0) ok = false;
        }
        if(ok){
            l = m;
        }else{
            r = m;
        }

    }
    cout << l << endl;
    return 0;
}