#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

#define int int64_t

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> v(n + 1);
    {
        int st = 1, f = n + 1;
        for (int i = 0; i < n + 1; i++) {
            if (i % 2 == 0) {
                v[i] = st;
                st++;
            } else {
                v[i] = f;
                f--;
            }
        }
    }
    string s;
    cin >> s;
    vector<pair<vector<int>, char>> a;
    vector<char> color;
    char last = s[0];
    a.push_back({{v[0]}, s[0]});
    for (int i = 0; i < n; i++) {
        if (s[i] != last) {
            last = s[i];
            a.push_back({{v[i + 1]}, last});
            if (s[i] == 'A') {
                a[a.size() - 1].first.push_back(a[a.size() - 2].first.back());
                a[a.size() - 2].first.pop_back();
            }
        }
        else {
            a[a.size() - 1].first.push_back(v[i + 1]);
        }
    }
    color.resize(a.size());
    int c_b = 0, c_r = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i].second == 'A') {
            if (a[i].first[0] < a[i].first[1]) {
                color[i] = 'r';
                c_r++;
            }
            else if (a[i].first[0] > a[i].first[1]) {
                color[i] = 'b';
                c_b++;
            }
            else {
                color[i] = 'h';
            }
        }
        else {
            color[i] = 'h';
        }
       /* for (auto x : a[i].first) {
            cout << x << " ";
        }
        cout << "\n";
        cout << a[i].second << " " << color[i] << "\n";*/
    }
    if (c_r > c_b) {
        for (int i = 0; i < a.size(); i++) {
            if (c_r <= c_b) {
                break;
            }
            if (color[i] == 'r') {
                reverse(a[i].first.begin(), a[i].first.end());
                //cout << "!\n";
                c_r--;
                c_b++;
            }
        }
    }
    else {
        for (int i = 0; i < a.size(); i++) {
            if (c_r >= c_b) {
                break;
            }
            if (color[i] == 'b') {
                reverse(a[i].first.begin(), a[i].first.end());
                c_r++;
                c_b--;
            }
        }
    }
    for (int i = 0; i < a.size(); i++) {
        for (auto x : a[i].first) {
            cout << x << " ";
        }
    }
    cout << "\n";
}

int32_t main() {
//#ifdef BIBIKOV
//    freopen("input", "r", stdin);
//    freopen("output", "w", stdout);
//#endif

    int tt = 1;
//    cin >> tt;
    while (tt--)
        solve();

    return 0;
}
