#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <list>
#include <map>
#include <cmath>
#include <algorithm>
#include <ctype.h>


#define PI 3.1415
#define D2R(A) (A / 180.0 * PI)
#define R2D(A) (A / PI * 180)

typedef unsigned long long ull;
typedef long long ll;

using namespace std;

typedef string::iterator si;

class elem
{
public:
	int pairs[64]{}, toMove = 0, lastInd = 0;

	elem()
	{
	}

};

ull fac(ull n)
{
	if (n < 2)
		return 1;
	return n * fac(n - 1);
}

int main()
{
	vector<elem> dp{};
	int n;

	cin >> n;

	dp.resize(n);
	dp[0].lastInd = 0;
	dp[0].toMove = 0;
	dp[0].pairs[0] = 1;

	for (int i = 1; i < n; i++)
	{
		dp[i].toMove = dp[i - 1].toMove == -1 ? dp[i - 1].lastInd : dp[i - 1].toMove - 1;
		dp[i].lastInd = dp[i - 1].toMove == dp[i - 1].lastInd ? dp[i - 1].lastInd + 1 : dp[i - 1].lastInd;
		memcpy(dp[i].pairs, dp[i - 1].pairs, 64);

		if (dp[i - 1].toMove > -1)
			dp[i].pairs[dp[i - 1].toMove] = 0;
		dp[i].pairs[dp[i - 1].toMove + 1] = 1;
	}

	ull ans = 0;

	for (int i = 0; i < 64; i++)
		if (dp[n - 1].pairs[i] && i > 0)
		{
			if (i == 1)
				ans += 2;
			else
			{
				ull
					a = fac(i + 1),
					b = fac(i - 1);
					// a = tgammal(i + 1) * (i + 1),
					// b = tgammal(i - 1) * (i - 1);

				ans += a / b;
			}
		}

	cout << ans / 2;
}

// 	ull n, k = 0;
// 	bool flag = true;
// 	vector<string> arr;
// 
// 	cin >> n;
// 
// 	arr.resize(n);
// 
// 	for (ull i = 0; i < n; i++)
// 	{
// 		string tmp;
// 
// 		cin >> tmp;
// 
// 		arr[i] = (tmp);
// 	}
// 
// 	map<pair<string &, int>, int> dict;
// 
// 	for (unsigned int i = 1; i <= arr[0].length() && flag; i++)
// 	{
// 		// dict.clear();
// 		for (int j = 0; j < n; j++)
// 		{
// 			pair<string &, int> tmp = pair<string &, int>(arr[j], i);
// 
// 			if (dict.find(tmp) == dict.end())
// 				dict[tmp] = 0;
// 
// 			dict[tmp]++;
// 		}
// 
// // 4
// // aabc
// // aacc
// // bbbb
// // bbad
// 
// //	8
// //	aab
// //	bbd
// //	bbd
// //	aac
// //	cfh
// //	bba
// //	cfu
// //	bba
// 		for (auto& a : dict)
// 			if (a.second % 2 == 1)
// 			{
// 				flag = false;
// 				break;
// 			}
// 		if (flag)
// 			k++;
// 		for (auto& a : dict)
// 			cout << string(a.first.first.begin(), a.first.first.begin() + a.first.second) << ':' << a.second << endl;
// 		cout << k << endl << endl;
// 	}
// 
// // 	for (auto& a : dict)
// // 		cout << a.first << ':' << a.second << endl;
// 	cout << k;
