def find_start(list_of_starts, start):
    ans = [el for el in list_of_starts if start.startswith(el)]
    if ans:
        return ans[len(ans) - 1]
    return "-1"


q, c = [int(el) for el in input().split()]
colored_vertice = {"-1": -1}
ways_to_color = []
for _ in range(q):
    question = input().split()
    if len(question) == 2:
        way = input()
        colored_vertice[way] = int(question[1])
        ways_to_color.append(way)
    else:
        path = input()
        path_color = find_start(way, path)
        color_initial = colored_vertice[path_color]
        if color_initial == -1:
            print(-1)
        else:
            result = color_initial
            path = path[len(path_color):]
            for el in path:
                if el == "R":
                    result = (result - 1) % c
                else:
                    result = (result + 1) % c
            print(result)