#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

int c;

struct Node {
    int x = -1;
    Node *l = nullptr, *r = nullptr;
    bool m = false;
};

Node *root = new Node();

void push(Node *v) {

    if (!v->l) v->l = new Node();
    if (!v->r) v->r = new Node();
    if (v->m) {
        v->l->x = (v->x + 1) % c;
        v->r->x = (v->x - 1 + c) % c;
        v->m = false;
        v->l->m = true;
        v->r->m = true;
    }

}

void color(Node *v, int x, int i, string &s) {
    push(v);
    if (i == s.size()) {
        v->x = x;
        v->m = true;
        push(v);
        return;
    }
    if (s[i] == 'L') {
        color(v->l, x, i + 1, s);

    }else {
        color(v->r, x, i + 1, s);
    }
}

int get(Node *v, int i, string &s) {
    push(v);
    if (i == s.size()) {
        return v->x;
    }
    if (s[i] == 'L') {
        return get(v->l, i + 1, s);
    }
    return get(v->r, i + 1, s);
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    int q;
    cin >> q >> c;
    while (q--) {
        int qt;
        cin >> qt;
        if (qt == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            color(root, x, 0, s);
        } else {
            string s;
            cin >> s;
            cout << get(root, 0, s) << '\n';
        }
    }
}
/*
6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2
R
 */
