#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

string bin(int x) {
    if (x == 0) return "";
    return bin(x / 2) + (char) ('0' + (char) (x % 2));
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int x;
        cin >> x;
        if (x < 0) x = -x;
        string s = "0" + bin(x);
        int n = s.length();
        vector<bool> add(n), sub(n);
        for (int i = 0; i < n; i++) {
            if (s[i] == '1' && s[i-1] == '0') {
                add[i-1] = true;
            }
            if (i > 0 && s[i] == '0' && s[i-1] == '1') {
                sub[i-1] = true;
            }
        }
        if (s[n-1] == '1') sub[n-1] = true;
        for (int i = 0; i < n - 1; i++) {
            if (add[i] && sub[i+1]) {
                add[i] = false;
                sub[i+1] = false;
                add[i+1] = true;
            }
            if (sub[i] && add[i+1]) {
                sub[i] = false;
                add[i+1] = false;
                sub[i+1] = true;
            }
        }
        int result = 0;
        for (int i = 0; i < n; i++) {
            if (add[i]) result++;
            if (sub[i]) result++;
        }
        cout << result;
    }
}
