/* 9-24-N CGSG,	PML №30 */

import java.util.ArrayList;
import java.util.Scanner;

public class D {
    static long q, c;
    static ArrayList<Long> colors = new ArrayList<>();
    static StringBuilder way = new StringBuilder();

    public static int convertPath(String str) {
        int startPath = 0;

        for (int i = 0; i < str.length(); i++) {
            if (str.charAt(i) == 'L') startPath = startPath * 2 + 1;
            if (str.charAt(i) == 'R') startPath = startPath * 2 + 2;
        }
        return startPath;
    }

    public static void addSet(int index, long value) {
        if (index >= colors.size()) {
            int sizePrev = colors.size();
            for (int i = sizePrev; i < sizePrev + index; i++) {
                colors.add(-1L);
            }
            colors.add(index, value);
        } else colors.set(index, value);
    }

    public static int findDad(int kid) {
        if (kid >= colors.size())
            addSet(kid, -1);
        if (kid == 0 || colors.get(kid) != -1)
            return kid;
        if (kid % 2 == 0)
            way.append("R", 0, 1);
        else
            way.append("L", 0, 1);
        kid = (kid - 1) / 2;
        return findDad(kid);
    }

    public static long changeColor(long prev, String path) {
        long res = prev;
        for (int i = 0; i < path.length(); i++) {
            if (path.charAt(i) == 'L')
                res = (res + 1) % c;
            if (path.charAt(i) == 'R')
                res = (res - 1 + c) % c;
        }
        return res;
    }

    /* 6 3 1 2 L 2 LL 1 0 LL 2 LLR 2 LR 2 R */
    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        q = s.nextInt();
        c = s.nextInt();
        int func;
        String str;

        for (int i = 0; i < 10; i++) {
            addSet(i, -1);
        }

        for (int i = 0; i < q; i++) {
            func = s.nextInt();
            switch (func) {
                case 1 -> {
                    int col = s.nextInt();
                    str = s.next();
                    addSet(convertPath(str), col);
                }
                case 2 -> {
                    way.delete(0, way.length());
                    str = s.next();
                    int dad = findDad(convertPath(str));
                    if (dad == 0)
                        System.out.println("-1");
                    else {
                        addSet(convertPath(str), changeColor(colors.get(dad), way.toString()));
                        System.out.println(colors.get(convertPath(str)));
                    }
                }
            }
        }
    }
}
