/* 9-24-N CGSG, PML №30 */

import java.util.ArrayList;
import java.util.Scanner;

record Word(String a, String b) {}

public class K {
    public static boolean collide(String a, String b, int k) {
        for (int i = 0; i < k; i++)
            if (a.charAt(i) != b.charAt(i))
                return false;
        return true;
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        String[] arr = new String[s.nextInt()];
        for (int i = 0; i < arr.length; i++) {
            arr[i] = s.next();
        }

        if (arr[0].length() == 1) {
            System.out.println("0");
            return;
        }

        int[] scores = new int[arr[0].length()];


        ArrayList<Word> collidedWords = new ArrayList<>();

        for (int k = 1; k < arr[0].length(); k++) {
            for (int i = 0; i < arr.length; i++) {
                for (int j = 0; j < arr.length; j++) {
                    if (i != j) {
                        Word o = new Word(arr[i], arr[j]);
                        Word a = new Word(arr[j], arr[i]);
                        if (!collidedWords.contains(o) && !collidedWords.contains(a) && collide(arr[i], arr[j], k)) {
                            collidedWords.add(o);
                            scores[k] += 1;
                        }
                    }
                }
            }
            collidedWords.clear();
        }

        int max = 0;
        int maxIndex = 1;
        for (int i = 1; i < scores.length; i++) {
            if (max < scores[i]) {
                max = scores[i];
                maxIndex = i + 1;
            }
        }

        System.out.println(maxIndex);
    }
}