#include <iostream>
#include <vector>

using namespace std;

long long F(vector<long long> &q)
{
	long long res = 0;
	for (auto i : q)
	{
		if (i == 0)
			res++;
		while (i > 0)
		{
			i /= 10;
			res++;
		}
	}
	return res;
}

long long f(long long a)
{
	long long res = 0;
	while (a > 0)
	{
		a /= 10;
		res++;
	}
	return res;
}

int main(void)
{
	long long s;
	cin >> s;
	vector<long long> q;
	long long i = 0;
	while (F(q) < s)
		q.push_back(i++);
	long long delta = F(q) - s;
	while (!q.empty() && delta != 0)
	{
		if (delta >= f(q[q.size() - 1]))
		{
			delta -= f(q[q.size() - 1]);
			q.pop_back();
		}
		else
		{
			delta -= f(q[0]);
			q.erase(q.begin());
		}
	}
	if (q.empty())
	{
		cout << -1;
		return 0;
	}
	cout << q.size() << '\n';
	cout << q[0] << " " << q[q.size()-1];
	return 0;
}