#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("avx,avx2,bmi2,fma")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);

using namespace std;

typedef long long ll;


int main() {
    int n;

    cin>>n;

    string data;
    cin>>data;

    vector<int> a(n+1, 0);

    int a_count = 0;

    for(int i = 0;i<n;i++){
        if(data[i] == 'A'){
            a_count++;
            a[i] = -1;
            a[i+1] = -1;
        }

    }

    int count = 0;

    for(int i = 0;i<n+1;i++){
        if(a[i] == -1){
            count++;
        }
    }

    vector<int> fill_in(count);

    for(int i = 1;i<count+1;i++){
        fill_in[i-1] = i;
    }

    reverse(fill_in.begin()+count/2, fill_in.end());

    int fill_count = 0;
    int random_count = count+1;

    for(int i = 0;i<n+1;i++){
        if(a[i] == -1){
            a[i] = fill_in[fill_count];
            fill_count++;
        }
        else{
            a[i] = random_count;
            random_count++;
        }
    }

    for(int i = 0;i<n+1;i++){
        cout<<a[i]<<" ";
    }


}
