#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

void solve() {
	int n, d;

	cin >> n;

	vector <vector<ll>> dp(n + 1, vector <ll>(n  + 1, 1e18));
	vector <vector<ll>> mn(n + 1, vector<ll>(n + 1, 1e18));


	for (int i = 0; i <= n; i++) {
		dp[0][i] = 0;
		mn[0][i] = 0;
	}
	dp[1][0] = 0;
	mn[1][0] = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			
			if (i - j - 1 >= 0 && j) {
				//cout << i << ' ' << j << ' ' << i - j - 1 << "\n";
				dp[i][j] = mn[i - j - 1][j - 1] + (j * (j + 1)) / 2;
				//cout << dp[i][j] << "\n";
				
			}
			if (j)mn[i][j] = min(dp[i][j], mn[i][j - 1]);
			//cout << mn[i][j] << ' ';
		}
		//cout << "\n";
	}
	ll ans = 1e18;
	for (int i = 0; i <= n; i++) ans = min(ans, dp[n][i]);
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}