#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

ll c;

ll M = 1e9 + 33, p = 37;

void solve() {
	int q;
	cin >> q >> c;
	string s;
	int t, x;

	map < ll, pair < pair<int, int>, pair<int, int >>> mp;
	
	for (int time = 0; time < q; time++) {
		cin >> t;
		if (t == 1) {
			cin >> x >> s;
			ll h = 0;
			int cntl = 0;
			for (int i = 0; i < s.size(); i++) {
				h = (h * p + s[i]) % M;
				if (s[i] == 'L') cntl++;
			}

			mp[h] = { {time, s.size()}, {x, cntl} };
	
		}
		else {
			cin >> s;

			int mxtime = -1,cntl = 0, sz = 0;
			x = 0;
			int nowcntl = 0;
			ll h = 0;
			for (int i = 0; i < s.size(); i++) {
				h = (h * p + s[i]) % M;
				if (s[i] == 'L') nowcntl++;
				if (mp.find(h) != mp.end()) {
					int ctime = mp[h].first.first;
					int csz = mp[h].first.second;
					int cx = mp[h].second.first;
					int ccntl = mp[h].second.second;

					if (mxtime < ctime) {
						cntl = ccntl;
						x = cx;
						sz = csz;
						mxtime = ctime;
					}


				}

			}
			
			if (mxtime == -1) cout << -1 << "\n";
			else {
				sz = s.size() - sz;
				cntl = nowcntl - cntl;
				int cntr = sz - cntl;
				//cout << cntl << ' ' << cntr << "\n";
				cout << ((x + c * ((int)1e6) + cntl - cntr) % c) << "\n";
			}

		}

	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}