#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <deque>
#include <queue>


using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 1000000007;
ll modP = 1000000007;

struct P
{
	ll f;
	ll s;
};
struct tr
{
	ll a;
	ll b;
	ll c;
};

void print(vector<tr>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].a << " " << vec[i].b << " " << vec[i].c << endl;
	}
	cout << endl;
}
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << " ";
	}
	cout << endl;
	return;
}

void print(vector<vector<ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		for (int j = 0; j < vec[i].size(); j++)
		{
			cout << vec[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
}

void print(vector<string>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << endl;
	}
	cout << endl;
}

void print(vector<P>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].f << " " << vec[i].s;
	}
}


ll gcd(ll a, ll b)
{
	if (a == 0)
	{
		return b;
	}
	else
	{
		return gcd(b % a, a);
	}
}


ll fpow(ll n, ll p)
{
	//cout << n << " " << p << endl;
	if (p == 1)
		return n;

	if (p % 2 == 0)
	{
		ll k = fpow(n, p / 2) % modP;
		return (k * k) % modP;
	}
	else
	{
		return ((fpow(n, p - 1) % modP) * n) % modP;
	}
}

vector<ll> St;
void buildSt(ll p, ll n)
{
	St.clear();
	St.push_back(1);
	for (int i = 1; i <= n; i++)
	{
		St.push_back((St.back() * p) % mod);
	}
	return;
}

vector<ll> fack(1, 1);

void bulidFack(ll n)
{
	//fack.clear();
	for (int i = 1; i <= n; i++)
	{
		fack.push_back((fack.back() * i) % mod);
	}
	return;
}
ll C(ll n, ll k)
{
	if (k > n)
		return 0;
	cout << n << " " << k << endl;
	return ((fack[n] * fpow(fack[k], mod - 2) % mod) * fpow(fack[n - k], mod - 2)) % mod;
}


int main()
{
	ll q, c;
	cin >> q >> c;
	vector<pair<ll, ll>> vec;
	vector<pair<ll, ll>> dp;
	vec.push_back({ -1, -1 });
	dp.push_back({ -1, -1 });
	ll cn = 1;
	ll qq = q;
	while (q--)
	{
		ll x;
		cin >> x;
		if (x == 1)
		{
			ll color;
			cin >> color;
			string s;
			cin >> s;
			ll v = 0;
			for (int i = 0; i < s.size(); i++)
			{
				if (s[i] == 'L')
				{
					if (vec[v].first == -1)
					{
						vec.push_back({ -1, -1 });
						vec[v].first = cn;
						cn++;
						dp.push_back({ -1, -1 });
						
					}
					v = vec[v].first;
				}
				else
				{
					if (vec[v].second == -1)
					{
						vec.push_back({ -1, -1 });
						vec[v].second = cn;
						cn++;
						dp.push_back({ -1, -1 });

					}
					v = vec[v].second;
				}
			}

			dp[v] = { qq - q, color };
		}
		else
		{
			ll t = qq + 1;
			//cout << t << "    {}";
			ll color2 = -1;
			string s;
			cin >> s;
			ll v = 0;
			for (int i = 0; i < s.size(); i++)
			{
				if (s[i] == 'L')
				{
					if (vec[v].first == -1)
					{
						vec.push_back({ -1, -1 });
						vec[v].first = cn;
						cn++;
						dp.push_back({ -1, -1 });

					}
					if (dp[v].first != -1 && dp[v].first < t)
					{
						//cout << "|||||||||||||||||||||| " << color2 << endl;
						t = dp[v].first;
						color2 = dp[v].second;
						//cout << "|||||||||||||||||||||| " << color2 << endl;
					}
					if (t != qq + 1)
					{
						 
						color2++;
						color2 += c;
						color2 %= c;
					}
					v = vec[v].first;

				}
				else
				{
					if (vec[v].second == -1)
					{
						vec.push_back({ -1, -1 });
						vec[v].second = cn;
						cn++;
						dp.push_back({ -1, -1 });

					}

					if (dp[v].first != -1 && dp[v].first < t)
					{
						t = dp[v].first;
						color2 = dp[v].second;
					}
					if (t != qq + 1)
					{
						color2--;
						color2 += c;
						color2 %= c;
					}

					v = vec[v].second;
				}
				//cout << "||||||||||||||||||||||88888888  " << color2 << endl;
			}
			if (dp[v].first < t && dp[v].first != -1)
			{
				color2 = dp[v].second;
			}
			cout  << color2 << endl;
			//cout << t << endl;
		}
	}
	return 0;
}