#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <deque>
#include <queue>


using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 5000000000000000007;
ll modP = 1000000007;

struct P
{
	ll f;
	ll s;
};
struct tr
{
	ll a;
	ll b;
	ll c;
};

void print(vector<tr>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].a << " " << vec[i].b << " " << vec[i].c << endl;
	}
	cout << endl;
}
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << " ";
	}
	cout << endl;
	return;
}

void print(vector<vector<ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		for (int j = 0; j < vec[i].size(); j++)
		{
			cout << vec[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
}

void print(vector<string>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << endl;
	}
	cout << endl;
}

void print(vector<P>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].f << " " << vec[i].s;
	}
}


ll gcd(ll a, ll b)
{
	if (a == 0)
	{
		return b;
	}
	else
	{
		return gcd(b % a, a);
	}
}


ll fpow(ll n, ll p)
{
	//cout << n << " " << p << endl;
	if (p == 1)
		return n;

	if (p % 2 == 0)
	{
		ll k = fpow(n, p / 2) % modP;
		return (k * k) % modP;
	}
	else
	{
		return ((fpow(n, p - 1) % modP) * n) % modP;
	}
}

vector<ll> St;
void buildSt(ll p, ll n)
{
	St.clear();
	St.push_back(1);
	for (int i = 1; i <= n; i++)
	{
		St.push_back((St.back() * p));
	}
	return;
}

vector<ll> fack(1, 1);

void bulidFack(ll n)
{
	//fack.clear();
	for (int i = 1; i <= n; i++)
	{
		fack.push_back((fack.back() * i) % mod);
	}
	return;
}
ll C(ll n, ll k)
{
	if (k > n)
		return 0;
	cout << n << " " << k << endl;
	return ((fack[n] * fpow(fack[k], mod - 2) % mod) * fpow(fack[n - k], mod - 2)) % mod;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll q;
	cin >> q;
	buildSt(2, 65);
	while (q--)
	{
		ll n;
		cin >> n;
		n = abs(n);
		vector<ll> vec;
		ll p = 1;
		for (int i = 2; i < 64; i++)
		{
			p *= (ll)2;
		}
		//cout << St[3];
		//return 0;
		while (p > 0)
		{
		//	cout << n << endl;
			if (n >= p)
			{
				n -= p;
				vec.push_back(1);
				p /= 2;
			}
			else
			{
				vec.push_back(0);
				p /= 2;
			}
		}
	//	print(vec);
		vec.push_back(0);
		vector<ll> vec2(vec.size() , 0);
		for (int i = 0; i < vec.size() - 1; i++)
		{
			if (vec[i] == 0 && vec[i + 1] == 1)
			{
				vec2[i] = 1;
			}
			if (vec[i] == 1 && vec[i + 1] == 0)
				vec2[i] = -1;
		}

		for (int i = 0; i < vec2.size() - 1; i++)
		{
			if (vec2[i] == 1 && vec2[i+ 1] == -1)
			{
				vec2[i] = 0;
				vec2[i + 1] = 1;
			}
		}

		for (int i = 0; i < vec2.size() - 1; i++)
		{
			if (vec2[i] == -1 && vec2[i + 1] == 1)
			{
				vec2[i] = 0;
				vec2[i + 1] = -1;
			}
		}
	//	print(vec2);
		ll ans = 0;
		for (int i = 0; i < vec2.size(); i++)
		{
			if (vec2[i] != 0)
			{
				ans++;
			}
		}
		//print(vec2);
		cout << ans << endl;
	}
	return 0;
}