#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>

using namespace std;

int main1() {
    int n;
    cin >> n;

    vector<int> a(n);
    int need_s = 0;
    for (auto& i : a) {
        cin >> i;
        need_s += i;
    }
    need_s = ceil(need_s * 1.0 / n);

    int l = 0, r = 0, s = a[0], mn_el = a[0];

    int res = 1e9;
    while (r < n && l < n) {
        cout << r << " " << l << " " << res << " " << s << " " << mn_el << "\n";
        if (s < need_s) {
            r++;
            s += a[r];
            mn_el = min(mn_el, a[r]);
        } else if (s == need_s) {
            res = min(res, r - l + 1);
            l++;
            r--;
            mn_el = 1e9;
            for (int i = l; i <= r; ++i) {
                mn_el = min(mn_el, a[i]);
            }
        } else if (s > need_s) {
            if (s - mn_el >= need_s)
                res = min(res, (r - l));
            else
                res = min(res, (r - l + 1));
            r--;
            l++;
            mn_el = 1e9;
            for (int i = l; i <= r; ++i) {
                mn_el = min(mn_el, a[i]);
            }
        }
    }

    cout << res;

    return 0;
}


int mainQQ() {
    int n;
    cin >> n;
    vector<int> numb(n);
    for (int i = 0; i < n; i++)
        cin >> numb[i];
    vector<vector<int>> tree;
}

int main3() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int d;
            cin >> d;
            a[i][j] = d;
        }
    }

    vector<pair<int, int>> magnet;

    for (int i = 0; i < n; ++i) {
        if (a[i][0] == 8 || a[i][0] == 7 || a[i][0] == 6) {
            magnet.push_back({i, 0});
        }
        if (a[i][m - 1] == 2 || a[i][m - 1] == 3 || a[i][m - 1] == 4) {
            magnet.push_back({i, m - 1});
        }
    }

    for (int j = 0; j < m; ++j) {
        if (a[0][j] == 7 || a[0][j] == 8 || a[0][j] == 1) {
            magnet.push_back({0, j});
        }
        if (a[n - 1][j] == 6 || a[n - 1][j] == 5 || a[n - 1][j] == 4) {
            magnet.push_back({n - 1, j});
        }
    }
}

int main() {
    int n;
    cin >> n;
    vector<string> words(n);
    for (int i = 0; i < n; i++)
        cin >> words[i];
    sort(words.begin(), words.end());
    int max = 1e6;
    for (int i = 0; i < n; i += 2) {
        int score = 0;
        for (int j = 0; j < min(words[i].length(), words[i + 1].length()); j++) {
           if (words[i][j] != words[i + 1][j]) break;
           score++; 
        }
        //cout << words[i] << " " << words[i + 1] << endl;
        if(score < max) max = score;
    }
    cout << max;

    return 0;
}