#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;
vector<int> LOGN(1000*100 + 1);
void full() {
    LOGN[1] = 0;
    LOGN[2] = 1;
    for (int i = 3; i < 100001; i++) {
        LOGN[i] = LOGN[i / 2] + 1;
    }
}

int main() {
   full();
   int n; cin >> n;
   vector<ll> Arr(n);
   vector<ll> Prefix(n+1, 0);
   vector<vector<ll>> Sparse(LOGN[n] + 1, vector<ll>(n));
   for (int i = 0; i < n; i++)
       cin >> Arr[i], Prefix[i+1] = Prefix[i] + Arr[i], Sparse[0][i] = Arr[i];

   for (int i = 1; (1 << i <= n); i++) {
       for (int j = 0; j < n; j++) {
           if (j + (1 << (i - 1)) > n) {
               Sparse[i][j] = Sparse[i - 1][j];
               continue;
           } else {
               Sparse[i][j] = min(Sparse[i - 1][j], Sparse[i - 1][j + (1 << (i - 1))]);
           }
       }
   }
   int need = (Prefix[n] + 1) / 2;
   int l = 1, r = n + 1;
   // cout << need;
   while (r - l > 1) {
       int mid = (l + r) / 2;
       bool check = false;
       for (int i = mid; i <= n; i++) {
           if ((Prefix[i] - Prefix[i - mid]) >= need) {
               // cout << i << " " << mid << " "<< Prefix[i] - Prefix[i - mid] << "\n";
               check = true;
           }
       }
       (check ? r : l) = mid;
   }
   // cout << r;
   int ans = r;
   for (int i = ans; i <= n; i++) {
       int sum = Prefix[i] - Prefix[i - ans];
       if (sum - min(Sparse[LOGN[ans]][i], Sparse[LOGN[ans]][i + ans - (1 << LOGN[ans])]) >= need) {
           cout << ans-1 << "\n";
           return 0;
       }
   }
    cout << ans << "\n";
}
