// fidor.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>

using namespace std;

class hsh {
	string str;

	long long osn = 1e9 + 7;
	long long mod = 1e9 + 9;

	int size;

	vector<long long> osn1;
	vector<long long> hsh1;

	hsh(string _str)
	{
		str = _str;
		size = str.size();
		osn1.resize(size + 1);
		osn1[0] = 1;
		hsh1.resize(size + 1);
		hsh1[0] = 0;

		for (int i = 1; i < size + 1; ++i)
		{
			osn1[i] = osn1[i - 1] * osn;
		}

		for (int i = 0; i < size; ++i)
		{
			hsh1[i + 1] = hsh1[i] + str[i] * osn1[i];
		}
	}


};

int main()
{
	int n;
	cin >> n;
	vector<int> v(n);
	multiset<int> s;
	vector<int> prs(n + 1);

	int k = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i];
		k += v[i];
	}
	k = k / 2 + k % 2;
	s.insert(v[0]);
	long long sum = v[0];

	//for (int i = 1; i < n; ++i)
	//{
	//	s.insert(v[i]);
	//}

	//for (auto i : s)
	//{
	//	cout << i << " ";
	//}

	//return 0;


	int l = 0, r = 0;
	int ans = n;
	while(true)
	{
		if (l == n)
		{
			break;
		}
		int mi;
		for (auto i : s)
		{
			mi = i;
			break;
		}

		if (r == n - 1) {
			if (sum < k)
			{
				break;
			}
			if (sum - mi >= k)
			{
				ans = min(ans, r - l);
			}
			ans = min(ans, r - l + 1);
			s.emplace(v[l]);
			sum -= v[l];
			++l;
		}
		else {
			if (sum >= k) {
				if (sum - mi >= k)
				{
					ans = min(ans, r - l);
				}
				ans = min(ans, r - l + 1);
				s.emplace(v[l]);
				sum -= v[l];
				++l;
			}
			else {
				s.insert(v[r + 1]);
				sum += v[r + 1];
				++r;
			}
		}
	}
	cout << ans;
	
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
