#include "bits/stdc++.h"
#define ll long long
using namespace std;

int k1=7,k2=31;
int mod1=1000000009,mod2=1000000007;

pair<int,int> sum(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (a.first + b.first) % mod1;
    res.second =  (a.second + b.second) % mod2;
    return res;
}

pair<int,int> mul(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (((ll)a.first) * ((ll)b.first)) % mod1;
    res.second =  (((ll)a.second) * ((ll)b.second)) % mod2;
    return res;
}

pair<int,int> sub(pair<int,int> a,pair<int,int> b){
    pair<int,int> res;
    res.first = (a.first + mod1 - b.first) % mod1;
    res.second =  (a.second + mod2 - b.second) % mod2;
    return res;
}

int main() {
    cin.sync_with_stdio(0);
    int q,c;
    cin >> q >> c;

    pair<int,int> cur = pair<int,int> (1,1);
    vector<pair<int,int>> pows(5*100001);
    for(int i=0;i<5*100001;i++){
        pows[i] = cur;
        cur = mul(cur,pair<int,int>(k1,k2));
    }

    map<pair<int,int>,pair<int,int>> mp;
    int prior = 0;
    for(int i=0;i<q;i++){
        int t;
        cin >> t;
        if(t == 1){
            int x;
            cin >> x;
            string s;
            cin >> s;
            pair<int,int> hash(0,0);
            for(int i=0;i<s.size();i++){
                pair<int,int> pp ((s[i] - 'a') + 1,(s[i] - 'a') + 1);
                hash = sum(hash, mul(pows[i],pp) );
            }
            mp[hash] = pair<int,int>(x,prior++);
        }
        if(t == 2){
            string s;
            cin >> s;
            pair<int,int> hash(0,0);
            int curP = -1;
            int curC = -1;
            for(int i=0;i<s.size();i++){
                pair<int,int> pp ((s[i] - 'a') + 1,(s[i] - 'a') + 1);
                hash = sum(hash, mul(pows[i],pp) );
                if(mp.find(hash) != mp.end() && mp[hash].second > curP){
                    curP = mp[hash].second;
                    curC = mp[hash].first;
                }else if( curC != -1){
                    if(s[i] == 'L') curC = (curC + 1) % c;
                    else curC = (curC + c - 1) % c;
                }
            }
            cout << curC << "\n";
        }
    }
    return 0;
}