#include "bits/stdc++.h"
#define ll long long
using namespace std;

vector<int> dot;
vector<int> a;

int buildTree(int v, int l, int r){
    if(r - l <= 1) {
        dot[v] = a[l];
        return dot[v];
    }
    int m = (l+r) / 2;
    dot[v] = min(buildTree(2*v + 2,m,r),buildTree(2*v + 1,l,m));
    return dot[v];
}

int getMin(int v,int l,int r, int tl,int tr){
    if(tl >= tr) return INT_MAX;
    if(tl == l && tr == r) return dot[v];
    int m = (l+r) / 2;
    int a = getMin(2*v+1,l,m,tl,min(tr,m));
    int b = getMin(2*v+2,m,r,max(tl,m),tr);
    return min(a,b);
}


int main() {
    cin.sync_with_stdio(0);
    int n;
    cin >> n;
    a=vector<int>(n);
    dot = vector<int> (5*n);
    ll p = 0;
    for(int i=0;i<n;i++){
        cin >> a[i];
        p += a[i];
    }
    buildTree(0,0,n);

    if(p % 2 == 1) p++;
    p /= 2;

    int l=0,r=n;
    while(r - l > 1){
        int m = (l+r) / 2;
        ll s = 0;
        bool ok = false;
        for(int i=0;i<m+1 && i<n;i++){
            s += a[i];
        }
        s -= getMin(0,0,n,0,m);
        if(s >= p) ok = true;
        for(int i=m;i<n;i++){
            s += a[i];
            s -= a[i-m];
            s += getMin(0,0,n,i-m,i);
            s -= getMin(0,0,n,i-m+1,i+1);
            if(s >= p) ok = true;
        }
        if(ok) r= m;
        else l = m;
    }

    cout << r << endl;


    return 0;
}