#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <list>
#include <map>
#include <cmath>
#include <algorithm>
#include <ctype.h>


#define PI 3.1415
#define D2R(A) (A / 180.0 * PI)
#define R2D(A) (A / PI * 180)

typedef unsigned long long ull;
typedef long long ll;

using namespace std;

typedef string::iterator si;

int dist(const string &a, const string &b, int len)
{
	int i = 0;

	while (i < len && a[i] == b[i])
		i++;

	return i;
}

int main()
{
	ull n = 0;                                      // 4
	vector<string> arr;								// aabc
	cin >> n;										// aacc
	arr.resize(n);									// bbbb
	for (int i = 0; i < n; i++)						// bbad
	{												//	8
		string tmp;									//	aab
		cin >> tmp;									//	bbd
		arr[i] = tmp;	    						//	bbd
	}												//	aac
	sort(arr.begin(), arr.end());					//	cfh
													//	bba
	int												//	cfu
		tmp,										//	bba
		len = arr[0].length(),
		k = dist(arr[0], arr[1], len);
	for (int i = 2; i < n; i += 2)
		if (k > (tmp = dist(arr[i], arr[i + 1], len)))
			k = tmp;
	cout << k << endl;
}

// // 4
// // aabc
// // aacc
// // bbbb
// // bbad
// //	8
// //	aab
// //	bbd
// //	bbd
// //	aac
// //	cfh
// //	bba
// //	cfu
// //	bba
