#include <bits/stdc++.h>
#define int unsigned long long
#define x first
#define y second

using namespace std;

int mod = 10000000013, p = 239;

vector<int> my_hash(string s) {
    int pi = 1, res = 0;
    vector<int> ans;
    for (int j = 0; j < s.size(); j++) {
        res += pi * (s[j] - 'a');
        res %= mod;
        pi *= p;
        pi %= mod;
        ans.push_back(res);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    int maxK;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    maxK = s[0].size();
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        g[i] = my_hash(s[i]);
    }
    int l = 0, r = maxK + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        unordered_set<int> v;
        for (int i = 0; i < n; i++) {
            if (v.find(g[i][m - 1]) == v.end()) {
                v.insert(g[i][m - 1]);
            } else {
                v.erase(g[i][m - 1]);
            }
        }
        if (v.size() == 0) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << l << '\n';
}


signed main() {
    //ios::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
