#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

const int MAXL = 18;
int pow10[MAXL];

int log(int x) {
    for (int i = 0; i < MAXL; i++) {
        if (pow10[i] > x) return i;
    }
    return MAXL - 1;
}

void solve() {
    int s;
    cin >> s;
    int l = 0, r = 0;
    int scur = 1;
    for (int i = 1; i < MAXL; i++) {
        int amount = ceil((s - scur + .0) / i);
        if (amount < 9 * pow10[i-1]) {
            scur += i * amount;
            r += amount;
            break;
        } else {
            scur += i * 9 * pow10[i-1];
            r += 9 * pow10[i-1];
        }
    }
    while (true) {
        if (s == scur) {
            cout << r - l + 1 << endl << l << " " << r << endl;
            break;
        }
        if (scur < s) {
            r += 1;
            scur += log(r);
        } else {
            l += 1;
            scur -= log(l);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    pow10[0] = 1;
    for (int i = 1; i < MAXL; i++) pow10[i] = pow10[i-1] * 10;
    solve();
}
