#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

const int MAXL = 18;
int pow10[MAXL];

int log(int x) {
    if (x == 0) return 1;
    for (int i = 0; i < MAXL; i++) {
        if (pow10[i] > x) return i;
    }
    return MAXL - 1;
}

pair<int,int> solve(int s) {
    int l = 0, r = 0;
    int scur = 1;
    for (int i = 1; i < MAXL; i++) {
        int amount = ceil((s - scur + .0) / i);
        if (amount < 9 * pow10[i-1]) {
            scur += i * amount;
            r += amount;
            break;
        } else {
            scur += i * 9 * pow10[i-1];
            r += 9 * pow10[i-1];
        }
    }
    while (true) {
        if (s == scur) {
            return make_pair(l,r);
        }
        if (scur < s) {
            scur += log(r);
            r += 1;
        } else {
            scur -= log(l);
            l += 1;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    pow10[0] = 1;
    for (int i = 1; i < MAXL; i++) pow10[i] = pow10[i-1] * 10;
    /*
    int s = 1;
    while (true) {
        pair<int,int> answer = solve(s);
        int len = 0;
        for (int x = answer.first; x <= answer.second; x++) {
            len += log(x);
        }
        cout << answer.first << " " << answer.second << " " << len << endl;
        if (len != s) {
            cout << "WRONG" << endl << s << endl;
            break;
        }
        s += 1;
    }
     */
    int s;
    cin >> s;
    pair<int,int> ans = solve(s);
    int l = ans.first, r = ans.second;
    cout << r - l + 1 << endl << l << " " << r << endl;

}
