//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx,avx2,bmi2,fma")
#include <iostream>
#include <algorithm>
#include <vector>

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);

using namespace std;

typedef long long ll;

vector<ll> pow(63);

int bin_search(ll &x) {
    ll now = 0;
    int ans = 0;
    while (now != x) {
        ll dif = abs(now - x);
        int k1 = lower_bound(pow.begin(), pow.end(), dif) - pow.begin();
        //cout<<k1<<endl;
        int k2 = k1 - 1;
        if (abs(pow[k1] - dif) < abs(pow[k2] - dif)) {
            if (now < x) {
                now += pow[k1];
            } else {
                now -= pow[k1];
            }
        } else {
            if (now < x) {
                now += pow[k2];
            } else {
                now -= pow[k2];
            }
        }
        ans++;
    }
    return ans;
}

int main() {
    fast

    pow[0] = 1;
    for (int i = 1; i <= 62; i++) {
        pow[i] = pow[i - 1] * 2;
    }
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i] = abs(a[i]);
    }

    for (auto &i : a) {
        cout << bin_search(i) << "\n";
    }
}
