#include <bits/stdc++.h>

using namespace std;

int c;

struct node
{
    node(int _l,int _r,int _col,int _p){l = _l;r =_r; col = _col;p = _p;};
    node(){l = -1;r = -1;col = -1;p = -2;};
    int l,r;
    int col,p;
};

vector<node> segTree(1,node());
string s;

int nnode()
{
    segTree.push_back(node());
    return int(segTree.size())-1;
}

void push(int indV)
{
    if(segTree[indV].l == -1)
    {
        int k = nnode();
        segTree[indV].l = k;
    }
    if(segTree[indV].r == -1)
    {
        int k = nnode();
        segTree[indV].r = k;
    }
    if(segTree[indV].p != -2)
    {
        segTree[indV].col = segTree[indV].p;
        segTree[segTree[indV].l].p = (segTree[indV].p+1)%c;
        segTree[segTree[indV].r].p = (segTree[indV].p-1+c)%c;
    }
    segTree[indV].p = -2;
    return ;
}

void modify(int indV,int ti,int tcol)
{
    push(indV);
    if(ti == s.size())
    {
        segTree[indV].p = tcol;
        return ;
    }

    if(segTree[indV].l == -1)
    {
        int k = nnode();
        segTree[indV].l = k;
    }
    if(segTree[indV].r == -1)
    {
        int k = nnode();
        segTree[indV].r = k;
    }
    if(s[ti] == 'L')
        modify(segTree[indV].l,ti+1,tcol);
    else
        modify(segTree[indV].r,ti+1,tcol);
    return ;
}
int64_t get(int indV,int ti)
{
   // cout << indV << ' ';
    push(indV);
   // cout << indV << ' ';
    if(ti == s.size())
    {
        return segTree[indV].col;
    }
    if(segTree[indV].l == -1)
    {
        int k = nnode();
        segTree[indV].l = k;
    }
    if(segTree[indV].r == -1)
    {
        int k = nnode();
        segTree[indV].r = k;
    }
    if(s[ti] == 'L')
        return get(segTree[indV].l,ti+1);
    else
        return get(segTree[indV].r,ti+1);
}


int main()
{
    //ios_base::sync_with_stdio(false);cin.tie(0);
    int q;
    cin >> q >> c;
    while(q--)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int x;
            cin >> x >> s;
            modify(0,0,x);
        }
        else
        {
            cin >> s;
            cout << get(0,0) << "\n";
        }
    }
    return 0;

}
