#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <deque>
#include <queue>


using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 1000000007;
ll modP = 1000000007;

struct P
{
	ll f;
	ll s;
};
struct tr
{
	ll a;
	ll b;
	ll c;
};

void print(vector<tr>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].a << " " << vec[i].b << " " << vec[i].c << endl;
	}
	cout << endl;
}
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << " ";
	}
	cout << endl;
	return;
}

void print(vector<vector<ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		for (int j = 0; j < vec[i].size(); j++)
		{
			cout << vec[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
}

void print(vector<string>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i] << endl;
	}
	cout << endl;
}

void print(vector<P>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].f << " " << vec[i].s;
	}
}


ll gcd(ll a, ll b)
{
	if (a == 0)
	{
		return b;
	}
	else
	{
		return gcd(b % a, a);
	}
}


ll fpow(ll n, ll p)
{
	//cout << n << " " << p << endl;
	if (p == 1)
		return n;

	if (p % 2 == 0)
	{
		ll k = fpow(n, p / 2) % modP;
		return (k * k) % modP;
	}
	else
	{
		return ((fpow(n, p - 1) % modP) * n) % modP;
	}
}

vector<ll> St;
void buildSt(ll p, ll n)
{
	St.clear();
	St.push_back(1);
	for (int i = 1; i <= n; i++)
	{
		St.push_back((St.back() * p) % mod);
	}
	return;
}

vector<ll> fack(1, 1);

void bulidFack(ll n)
{
	//fack.clear();
	for (int i = 1; i <= n; i++)
	{
		fack.push_back((fack.back() * i) % mod);
	}
	return;
}
ll C(ll n, ll k)
{
	if (k > n)
		return 0;
	cout << n << " " << k << endl;
	return ((fack[n] * fpow(fack[k], mod - 2) % mod) * fpow(fack[n - k], mod - 2)) % mod;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> vec(n, vector<ll>(m, 0));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> vec[i][j];
		}
	}

	//print(vec);
	ll ansi, ansj;
	for (int i = 0; i < n; i++)
	{
		ll c = 0;
		for (int j = 0; j < m; j++)
		{
			if (vec[i][j] != 3 && vec[i][j] != 7)
				c++;
		}
		if (c <= 1)
			ansi = i;

		//cout << c << endl;
	}
	for (int j = 0; j < m; j++)
	{
		ll c = 0;
		for (int i = 0; i < n; i++)
		{
			if (vec[i][j] != 1 && vec[i][j] != 5)
				c++;
		}
		if (c <= 1)
			ansj = j;

		//cout << c << endl;
	}
	cout << ansi + 1 << " " << ansj + 1<< endl;

	vector<ll> w(n, 0);
	vector<ll> h(m, 0);
	for (int i = 0; i <= ansi; i++)
	{
		for (int j = 0; j < ansj; j++)
		{
			if (abs(vec[i][j] - 4) > 1)
			{
				//cout << i << " " << j << endl;
				w[i]++;
				h[j]++;
			}
		}
	}
	//cout << "--------------------\n";
	for (int i = ansi + 1; i < n; i++)
	{
		for (int j = 0; j <= ansj; j++)
		{
			if (abs(vec[i][j] - 2) > 1)
			{
				//cout << i << " " << j << endl;
				w[i]++;
				h[j]++;
			}
		}
	}
	//cout << "--------------------\n";
	for (int i = 0; i < ansi; i++)
	{
		for (int j = ansj; j < m; j++)
		{
			if (abs(vec[i][j] - 6) > 1)
			{
				//cout << i << " " << j << endl;
				w[i]++;
				h[j]++;
			}
		}
	}
	//cout << "--------------------\n";
	for (int i = ansi; i < n; i++)
	{
		for (int j = ansj + 1; j < m; j++)
		{
			if (vec[i][j] != 8 && vec[i][j] != 1 && vec[i][j] != 7)
			{
				//cout << i << " " << j << endl;
				w[i]++;
				h[j]++;
			}
		}
	}
	//cout << "--------------------\n";
	ll mxw = 0;
	ll mxwi;
	ll mxh = 0;
	ll mxhi;
	for (int i = 0; i < w.size(); i++)
	{
		if (mxw < w[i])
		{
			mxw = w[i];
			mxwi = i;
		}
	}
	for (int i = 0; i < h.size(); i++)
	{
		if (mxh < h[i])
		{
			mxh = h[i];
			mxhi = i;
		}
	}
	//cout << 1111111111111111;
	if (mxh < 2)
	{
		mxhi = ansi;
	}
	if (mxw < 2)
	{
		mxwi = ansj;
	}
	cout << mxwi + 1 << " " << mxhi + 1 << endl;
	//print(w);
	//print(h);
	/*
	ll k = 0;
	ll kl = 0;
	for (int i = 0; i < n; i++)
	{
		if (i < ansi)
		{
			if (vec[i][ansj] != 5)
			{
				k++;
				kl = i;
			}
		}
		if (i > ansi)
		{
			if (vec[i][ansj] != 1)
			{
				k++;
				kl = i;
			}
		}
	}

	ll ans2i;
	ll ans2j;
	if (k == 0)
	{
		ans2i = ansi;
	}
	if (k == 1)
	{
		ans2i = kl;
		ll kk = 0;
		for (int j = 0; j < m; j++)
		{
			if(j < )
		}
	}
	if (k > 1)
	{
		ans2j = ansj;
		ll h = ansj + 1;
		if (ansj + 1 == m)
		{
			ansi -= 2;
		}


		if (h == ansj + 1)
		{
			ll kk = 0;
			for (int i = 0; i < n; i++)
			{
				if (i < ansi)
				{
					if (vec[i][h] != 7 && vec[i][h] != 6 && vec[i][h] != 5)
						kk = i;
				}
				if (i >= ansi)
				{
					if (vec[i][h] != 7 && vec[i][h] != 8 && vec[i][h] != 1)
						kk = i;
				}
			}
			cout << ansi << " " << ansj << endl << kk << " " << ans2j;
			return 0;
		}
		else
		{
			ll kk = 0;
			for (int i = 0; i < n; i++)
			{
				if (i < ansi)
				{
					if (vec[i][h] != 3 && vec[i][h] != 4 && vec[i][h] != 5)
						kk = i;
				}
				if (i >= ansi)
				{
					if (vec[i][h] != 1 && vec[i][h] != 2 && vec[i][h] != 3)
						kk = i;
				}
			}
			cout << ansi << " " << ansj << endl << kk << " " << ans2j;
			return 0;
		}
	}
	*/
	return 0;
}