#include <iostream>
using namespace std;

#define int long long

pair<int, int> temp(int x) {
    int n = 2;
    x = abs(x);
    while(n < x) {
        n = (n << 1);
    }
    return {n / 2, n};
}

int move(int a) {
    int x, y;
    pair<int, int> z = temp(a);
    x = z.first;
    y = z.second;
    if(abs(a) == abs(x) || abs(a) == abs(y)) {
        return 1;
    }
    if(a == 0) {
        return 0;
    }
    int t1 = abs(a-x);
    int t2 = abs(y - a);
    return min(move(t1), move(t2)) + 1;
}

signed main() {
    ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int t; cin >> t;
    while(t--) {
        int a; cin >> a;
        cout << move(abs(a)) << '\n';
    }
    return 0;
}
