#include<bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
int n, m, t;


void solve() {
    cin >> n;
    vector<int> logs(n + 1);
    logs[1] = 0;
    for (int i = 2; i <= n; i++) logs[i] = logs[i / 2] + 1;
    int k = logs[n] + 2;
    vector<vector<int>> sparse(k, vector<int>(n + 1));
    vector<int> a(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }
    vector<int> pref(n);
    partial_sum(a.begin(), a.end(), pref.begin());
    int res = n;
    int need = (sum + 1) / 2;
    for (int i = 0; i < n; i++) sparse[0][i] = a[i];
    for (int j = 1; j < k; j++) {
        for (int i = 0; i < n; i++) {
            sparse[j][i] = min(sparse[j - 1][i], sparse[j - 1][min(i + (1 << (j - 1)), n - 1)]);
        }
    }

    int left = 0, right = n + 1;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        bool found = false;
        for (int i = 0; i + mid <= n; i++) {
            int l = i, r = i + mid;
            int cur = pref[r - 1];
            if (l > 0) cur -= pref[l - 1];
            int len = r - l;
            cur -= (min(sparse[logs[len]][l], sparse[logs[len]][r - (1 << logs[len])]));
            if (cur >= need) {
                right = mid;
                res = min(res, mid - 1);
                found = true;
                break;
            }
        }
        if (!found) left = mid;

    }
    cout << res;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}